//C-  -*- C++ -*-
//C- DjVu Reference Library (v. 3.0)
//C- 
//C- Copyright  1999-2001 LizardTech, Inc. All Rights Reserved.
//C- The DjVu Reference Library is protected by U.S. Pat. No.
//C- 6,058,214 and patents pending.
//C- 
//C- This software is subject to, and may be distributed under, the
//C- GNU General Public License, Version 2. The license should have
//C- accompanied the software or you may obtain a copy of the license
//C- from the Free Software Foundation at http://www.fsf.org .
//C- 
//C- The computer code originally released by LizardTech under this
//C- license and unmodified by other parties is deemed the "LizardTech
//C- Original Code."
//C- 
//C- With respect to the LizardTech Original Code ONLY, and subject
//C- to any third party intellectual property claims, LizardTech
//C- grants recipient a worldwide, royalty-free, non-exclusive license
//C- under patent claims now or hereafter owned or controlled by
//C- LizardTech that are infringed by making, using, or selling
//C- LizardTech Original Code, but solely to the extent that any such
//C- patent(s) is/are reasonably necessary to enable you to make, have
//C- made, practice, sell, or otherwise dispose of LizardTech Original
//C- Code (or portions thereof) and not to any greater extent that may
//C- be necessary to utilize further modifications or combinations.
//C- 
//C- The LizardTech Original Code is provided "AS IS" WITHOUT WARRANTY
//C- OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//C- TO ANY WARRANTY OF NON-INFRINGEMENT, OR ANY IMPLIED WARRANTY OF
//C- MERCHANTIBILITY OR FITNESS FOR A PARTICULAR PURPOSE.
// 
// $Id: JPEGDecoder.h,v 1.13 2001/01/04 22:04:55 bcr Exp $
// $Name: DjVu3_snapshot $

#ifndef _JPEGDECODER_H_
#define _JPEGDECODER_H_

#include "GSmartPointer.h"

class ByteStream;
class GPixmap;

#ifdef NEED_JPEG_DECODER

#ifdef __cplusplus
extern "C" {
#endif

#include <jinclude.h>
#include <jpeglib.h>
#include <jerror.h>

#ifdef __cplusplus
}
#endif

#include <string.h>
#include <setjmp.h>

/** @name JPEGDecoder.h
    Files #"JPEGDecoder.h"# and #"JPEGDecoder.cpp"# implement an
    interface to the decoding subset of the IJG JPEG library.
    @memo
    Decoding interface to the IJG JPEG library.
    @version
    #$Id: JPEGDecoder.h,v 1.13 2001/01/04 22:04:55 bcr Exp $#
    @author
    Parag Deshmukh <parag@sanskrit.lz.att.com> 
*/
//@{

/** This class ensures namespace isolation. */
class JPEGDecoder {
public:
  /** Decodes the JPEG formated ByteStream */ 
  static GP<GPixmap> decode(ByteStream & bs);
};

//@}

#endif // NEED_JPEG_DECODER
#endif // _JPEGDECODER_H_
